#line 6 "/home/dodo/tmp/dsync-1.0/src/main.u"

#include <libssh2.h>
#include <libssh2_sftp.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include <ctype.h>
#include <netdb.h>
#include <stdlib.h>
#include <dirent.h>
#include <sys/stat.h>
#include "eprintf.h"
#include "config.h"
#include "secode.cx"
#include "fnmanip.c"


#line 6 "/home/dodo/tmp/dsync-1.0/src/list.u"

typedef struct finfo {
  char *name;
  uint64_t modtime;
  struct finfo *prev,*next;
} flist_t;

#line 82 "/home/dodo/tmp/dsync-1.0/src/main.u"

static cfg_settings_t settings;

#line 141 "/home/dodo/tmp/dsync-1.0/src/main.u"

static int command; static cfg_target_t *target;

#line 5 "/home/dodo/tmp/dsync-1.0/src/sftp.u"

static LIBSSH2_SESSION *SSHsession;
static int SSHfd;
static LIBSSH2_SFTP *SFTPsession;

#line 31 "/home/dodo/tmp/dsync-1.0/src/main.u"
int force_compare;

#line 50 "dsync.c"

void writef(void *F, char *K, size_t L);
void read_config();
static void parse_args(int argc, char **argv);
void e_list();
void start_target();
void end_target();
flist_t *get_remote_list();
int read_remote_file(char *name, uint8_t **buffer, size_t *len);
int write_remote_file(char *name, uint8_t *buffer, size_t len);
void e_mark();
int write_remote_list(flist_t *L);
void e_update();
int update_file(flist_t *L);
void show_help();
int connect_host_tcp4(char *hostname, int port);
int block_read(void *handle, int (*func)(void *,char *, size_t),
               char **buffer, size_t *len);
static int block_read_real 
              (void *handle, int (*func)(void *,char *, size_t),
               char **buffer, size_t *len);
static int auth_passwd(char *user,char *host);
static void kbd_callback(const char *name, int name_len, 
             const char *instruction, int instruction_len, int num_prompts,
             const LIBSSH2_USERAUTH_KBDINT_PROMPT *prompts,
             LIBSSH2_USERAUTH_KBDINT_RESPONSE *responses,
             void **abstract);
static int auth_kb(char *user);
int sftp_read_file(char *path, uint8_t **buffer, size_t *len);
static LIBSSH2_SFTP_HANDLE *sftp_open(char *path, int mode);
int sftp_write_file(char* path, uint8_t *buffer, size_t len);
static void serialize_list(flist_t *L, uint8_t **Rbuffer, size_t *Rlen);
static int hexprt(uint8_t *T, int bytes, uint64_t value);
static int hexget(uint8_t *T, int bytes, uint64_t *RV);
static int bytep(uint8_t *b, uint32_t V);
static int byteg(uint8_t *b, uint32_t *RV);
static flist_t *deserialize_flist(uint8_t *buffer, size_t len);
flist_t *get_dir_contents();
void print_flist(flist_t *L);
void flist_free_node(flist_t *F);
int local_read_file(char *path, uint8_t **buffer, size_t *len);
int local_read(void *f,char *Z, size_t len);
int local_write_file(char* path, uint8_t *buffer, size_t len);
int sftp_connect(char *host, char *user);
void sftp_disconnect();
flist_t* flist_append(flist_t *L, uint64_t mtime, uint8_t *name);
flist_t* flist_remove_node(flist_t *F);
flist_t* flist_append_node(flist_t *L, flist_t *F);
flist_t* flist_new();
#line 37 "/home/dodo/tmp/dsync-1.0/src/main.u"

#line 86 "/home/dodo/tmp/dsync-1.0/src/main.u"

void writef(void *F, char *K, size_t L)
{
  fwrite(K, 1, L, F);
}

void read_config()
{
  int i;
  char *fn;
  char *e;
  fn= "dsync.cfg";
  e= cfg_parse_settings(fn, &settings);
  if (e)
  {
    eprintf("error reading config file %s: %s\n", fn, e);
    exit(1);
  }
  for(i=0;i<settings.N_target;i++)
  {
    if (!settings.target[i].G_name)
    {
      eprintf("invalid configuration, one of the targets have no name.\n");
      exit(1);
    }
    if (!settings.target[i].G_dir)
    {
      eprintf("invalid configuration, target %s has no directory\n",
                  settings.target[i].name);
      exit(1);
    }
    if (!settings.target[i].G_method || (settings.target[i].method!=1 &&
                                 settings.target[i].method!=2) )
    {
      eprintf("invalid configuration, target %s must have a method:\n"
              " either sftp or file.\n", settings.target[i].name);
      exit(1);
    }
    if (settings.target[i].method==1)
    {
       if (!settings.target[i].G_host || !settings.target[i].G_user)
       {
         eprintf("invalid configuration, host and user must be defined "
                 "\n for sftp target %s.\n", settings.target[i].name);
         exit(1);
       }
    }
  }
  if (!settings.G_update_freq) settings.update_freq= 5;
}

#line 145 "/home/dodo/tmp/dsync-1.0/src/main.u"

static void parse_args(int argc, char **argv)
{
   int i;
   char *tgtname;
   if (argc==2)
   {
     command= 'U';
     tgtname= argv[1];
     goto done;
   }
   if (argc==3)
   {
     if (!strcmp(argv[1],"update")) { command= 'U'; tgtname= argv[2]; 
                                      goto done; }
     if (!strcmp(argv[1],"force")) { command= 'F'; tgtname= argv[2]; 
                                      goto done; }
     if (!strcmp(argv[1],"mark")) { command= 'M'; tgtname= argv[2]; 
                                      goto done; }
     if (!strcmp(argv[1],"list")) { command= 'L'; tgtname= argv[2]; 
                                      goto done; }
     goto usage;
   }
   goto usage;
done:
   for(i=0;i<settings.N_target;i++)
       if (!strcmp(settings.target[i].name, tgtname)) break;
   if (i==settings.N_target)
   {
     eprintf("can't find target %s in configuration file.\n", tgtname);
     goto usage;
   }
   target= settings.target+i;
   return ;
usage:
   eprintf("usage: dsync command target\n"
           "   command is one of:\n"
           "     update     Updates the modified files on target.\n"
           "     force      Uploads all files in the directory to the target.\n"
           "     mark       Marks the target as up-to-date, without uploading"
         "\n                any files other than the file list.\n"
           "     list       lists which files need to be updated on the target."
         "\n                Nothing is uploaded.\n"
           "     help       Displays a help page, no target should be given."
           "   If no command is given, it's assumed to be 'update'.\n");
   exit(1);
}

#line 197 "/home/dodo/tmp/dsync-1.0/src/main.u"

void e_list()
{
  flist_t *TL, *LL,*F,*N,*K;

  LL= get_dir_contents();
  if (!LL) return ;

  start_target();
  TL= get_remote_list();
  if (!TL) goto no_remote;

  for(F=TL->next;F!=TL;F=N)
  {
    N= F->next;
    for(K=LL->next;K!=LL;K=K->next)
      if (!strcmp(K->name,F->name))
      {
        flist_remove_node(K);
        if (K->modtime>F->modtime)
          printf("u %s\n", F->name);
        if (K->modtime<F->modtime)
          printf("b %s\n", F->name);
        flist_free_node(K);
        break;
      }
    if (K==LL) printf("O %s\n", F->name);
    flist_remove_node(F);
    flist_free_node(F);
  }

  flist_free_node(TL);
  end_target();

no_remote:

  for(K=LL->next;K!=LL;K=N)
  {
    N= K->next;
    flist_remove_node(K);
    printf("N %s\n", K->name);
    flist_free_node(K);
  }

  flist_free_node(LL);
  printf("Listing complete.\n");
}

#line 249 "/home/dodo/tmp/dsync-1.0/src/main.u"

void start_target()
{
  if (target->method==2) return ;
  if (sftp_connect(target->host, target->user)) exit(1);
}

void end_target()
{
  if (target->method==2) return ;
  sftp_disconnect();
}

#line 266 "/home/dodo/tmp/dsync-1.0/src/main.u"

flist_t *get_remote_list()
{
   char *fn;
   flist_t *L;
   uint8_t *buffer; size_t len;

   if (read_remote_file("files.lst", &buffer, &len))
   {
     if (!buffer) return NULL;
   }
   L= deserialize_flist(buffer,len);
   free(buffer);
   return L;
}

int read_remote_file(char *name, uint8_t **buffer, size_t *len)
{
   char *fn; int R;
   fn= fnmani_child(target->dir, name);
   if (target->method==2) R= local_read_file(fn,buffer,len);
   else R= sftp_read_file(fn,buffer,len);
   free(fn);
   return R;
}

int write_remote_file(char *name, uint8_t *buffer, size_t len)
{
   char *fn; int R;
   fn= fnmani_child(target->dir, name);
   if (target->method==2) R= local_write_file(fn,buffer,len);
   else R= sftp_write_file(fn,buffer,len);
   free(fn);
   return R;
}

void e_mark()
{
  flist_t *L;
  uint8_t *buffer; size_t len;
  L= get_dir_contents();
  if (!L) return ;
  serialize_list(L, &buffer, &len);
  start_target();
  write_remote_file("files.lst", buffer,len);
  free(buffer);
  end_target();
  printf("Marking complete.\n");
}

int write_remote_list(flist_t *L)
{
  uint8_t *buffer; size_t len;
  int R;
  serialize_list(L, &buffer, &len);
  R= write_remote_file("files.lst", buffer,len);
  free(buffer);
  return R;
}


void e_update()
{
  flist_t *LL, *TL,*L,*N,*F;
  char g[200];
  int updates;

  LL= get_dir_contents();
  if (!LL) return ;
  start_target();
  if (!force_compare)
  {
    TL= get_remote_list();
    if (!TL)
    {
      printf("Couldn't fetch remote list. This will be a full update\n"
             "do you want to continue? Y/N:");
      fflush(stdout);
      fgets(g, 200, stdin);
      if (g[0]!='y' && g[0]!='Y') goto done;
    }
  }

  updates= 0;
  if (!TL) TL= flist_new();

  for(L=LL->next;L!=LL;L=N)
  {
    N= L->next; 
    flist_remove_node(L);
    for(F=TL->next;F!=TL;F=F->next)
      if (!strcmp(F->name, L->name))
        break;

    if (F==TL || F->modtime<L->modtime)
    {
       printf("updating %s\n", L->name);
       if (update_file(L))
       {
         flist_free_node(L);
         continue;
       }
       updates++;
       if (updates==settings.update_freq)
       {
          if (write_remote_list(TL)) break;
          updates= 0;
       }
       if (F!=TL) { flist_remove_node(F); flist_free_node(F); }
       flist_append_node(TL,L);
    }
  }
  if (updates!=0)
     write_remote_list(TL);

done:
  end_target();
}

int update_file(flist_t *L)
{
  uint8_t *buffer; size_t len;
  int R;

  R= local_read_file(L->name,&buffer, &len);
  if (R) { if (buffer) free(buffer); return R; }
  R= write_remote_file(L->name, buffer, len);
  free(buffer);
  return R;
}

#line 398 "/home/dodo/tmp/dsync-1.0/src/main.u"

void show_help()
{
  puts(
#line 402 "dsync.c"
"\n"
"dsync - backup tool.\n"
"\n"
"Copyright (c) 2014 by \305\236\303\274kr\303\274 \303\207\304\261nar.\n"
"\n"
"All rights reserved.\n"
"\n"
"Redistribution and use in source and binary forms, with or without\n"
"modification, are permitted provided that the following conditions\n"
"are met:\n"
"\n"
"1. Redistributions of source code must retain the above copyright notice,\n"
"   this list of conditions and the following disclaimer.\n"
"\n"
"2. Redistributions in binary form must reproduce the above copyright\n"
"   notice, this list of conditions and the following disclaimer in the\n"
"   documentation and/or other materials provided with the distribution.\n"
"\n"
"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS\n"
"\042AS IS\042 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT\n"
"LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR\n"
"A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT\n"
"HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,\n"
"SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED\n"
"TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR\n"
"PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF\n"
"LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING\n"
"NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\n"
"SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n"
"\n"
"This is a backup tool which can upload files to a locally mounted disk\n"
"or a remote directory by connecting thru the sftp protocol. \n"
"\n"
"It doesn\047t provide two-way synchronization. The files are supposed to\n"
"be modified on a central computer and then backed up to other locations.\n"
"\n"
"The command line format for it is:\n"
"\n"
"dsync command target\n"
"\n"
"command is one of:\n"
"   update     Updates the modified files on target.\n"
"   force      Uploads all files in the directory to the target.\n"
"   mark       Marks the target as up-to-date, without uploading\n"
"              any files other than the file list.\n"
"   list       Lists which files need to be updated on the target.\n"
"              Nothing is uploaded.\n"
"   help       Displays this help message. No target argument should\n"
"              be given.\n"
"\n"
"If no command is given, it\047s assumed to be \047update\047.\n"
"\n"
"In order to synchronize the contents of a directory, you should create a\n"
"configuration file in it and tell the program at which locations you want\n"
"to back the contents up. This file should be called \042dsync.cfg\042.\n"
"\n"
"The configuration file consists of a list of targets. Each target is given\n"
"by the following two formats:\n"
"\n"
"  target {\n"
"    name \042name\042\n"
"    method file\n"
"    dir \042directory_name\042\n"
"  }\n"
"\n"
"OR\n"
"\n"
"  target {\n"
"    name \042name\042\n"
"    method sftp\n"
"    dir  \042remote_sftp_directory\042\n"
"    host \042hostname\042\n"
"    user \042username\042\n"
"  }\n"
"\n"
"The name is used to identify which target you want to update from the command\n"
"line. Passwords can\047t be stored in these configuration files.\n"
"\n"
"In addition to these target definitions, there is one more configuration\n"
"option. This option controls how frequently the database on the remote\n"
"directory is updated. It\047s given as:\n"
"\n"
"  update_freq  5\n"
"\n"
"Five is the default value. When the program is updating multiple files on a\n"
"given run, it updates the remote database after uploading this many files.\n"
"This is done in order to prevent work going missing after a connection \n"
"problem in the middle of a run.\n"
"\n"
"The program can only process a flat hierarchy. It doesn\047t recurse into \n"
"sub-directories. Also, you\047re supposed to first change your working directory\n"
"into the source directory and then invoke dsync from there.\n"

#line 406 "/home/dodo/tmp/dsync-1.0/src/main.u"
  );
}
#line 5 "/home/dodo/tmp/dsync-1.0/src/conn.u"

int connect_host_tcp4(char *hostname, int port)
{
  struct addrinfo hints;
  struct addrinfo *res, *ai;
  char portbuf[20];
  int R,fd;

  sprintf(portbuf, "%d", port);

  memset(&hints, 0, sizeof(struct addrinfo));
  hints.ai_family = AF_INET;
  hints.ai_socktype = SOCK_STREAM;
  hints.ai_flags = AI_NUMERICSERV;
  hints.ai_protocol = 0;

  R= getaddrinfo(hostname, portbuf, &hints, &res);
  if (R)
  {
    eprintf("can't resolve %s: %s\n", hostname, gai_strerror(R));
    return -1;
  }

  for(ai=res;ai;ai=ai->ai_next)
  {
    fd= socket(ai->ai_family, ai->ai_socktype, ai->ai_protocol);
    if (fd<0)
    {
      eprintf("can't create socket: %s\n", strerror(errno));
      continue;
    }
    eprintf("Trying to connect %s : ", hostname);
    if (connect(fd, ai->ai_addr, ai->ai_addrlen))
    {
       eprintf(" %s\n", strerror(errno));
       close(fd);
    }
    else 
    {
       eprintf(" OK\n");
       freeaddrinfo(res);
       return fd;
    }
  }
  freeaddrinfo(res);
  eprintf("couldn't connect with any address\n");
  return -1;
}
#line 15 "/home/dodo/tmp/dsync-1.0/src/read.u"

int block_read(void *handle, int (*func)(void *,char *, size_t),
               char **buffer, size_t *len)
{
  size_t L;
  int R;
  L= 0;
  *buffer= NULL;
  R= block_read_real(handle, func, buffer, &L);
  (*buffer)[L]= 0;
  if (len) *len= L;
  return R;
}

static int block_read_real 
              (void *handle, int (*func)(void *,char *, size_t),
               char **buffer, size_t *len)
{
    char *xb;
    static const int rsize=2000;
    int r;
    int R,B;
    size_t pos= *len;

    B= 0;
    xb= malloc(rsize);
    R= (*func)(handle, xb, rsize);
    if (R<=0)    goto eof_or_error;
    
    B= R;
    *len+= B;
    R= block_read_real(handle, func, buffer, len);

    memcpy(*buffer + pos, xb, B);
    return R;
eof_or_error:
    free(xb);
    *buffer= malloc(*len+1);
    return 0;
}

#line 101 "/home/dodo/tmp/dsync-1.0/src/sftp.u"

static int auth_passwd(char *user,char *host)
{
   char *Z;
   char g[200];
   printf("password for %s@%s:",user,host);
   fflush(stdout);
   fgets(g, 200, stdin);
   Z= strchr(g,'\r'); if (Z) Z[0]= 0;
   Z= strchr(g,'\n'); if (Z) Z[0]= 0;

   if (libssh2_userauth_password(SSHsession, user, g))
   {
     eprintf("password authentication failed.\n");
     return 0;
   }
   return 1;
}


static void kbd_callback(const char *name, int name_len, 
             const char *instruction, int instruction_len, int num_prompts,
             const LIBSSH2_USERAUTH_KBDINT_PROMPT *prompts,
             LIBSSH2_USERAUTH_KBDINT_RESPONSE *responses,
             void **abstract)
{
    int i;
    size_t n;
    char buf[1024];
    (void)abstract;

    fprintf(stderr, "Performing keyboard-interactive authentication.\n");

    fprintf(stderr, "Authentication name: '");
    fwrite(name, 1, name_len, stderr);
    fprintf(stderr, "'\n");

    fprintf(stderr, "Authentication instruction: '");
    fwrite(instruction, 1, instruction_len, stderr);
    fprintf(stderr, "'\n");

    fprintf(stderr, "Number of prompts: %d\n\n", num_prompts);

    for (i = 0; i < num_prompts; i++) {
        fprintf(stderr, "Prompt %d from server: '", i);
        fwrite(prompts[i].text, 1, prompts[i].length, stderr);
        fprintf(stderr, "'\n");

        fprintf(stderr, "Please type response: ");
        fgets(buf, sizeof(buf), stdin);
        n = strlen(buf);
        while (n > 0 && strchr("\r\n", buf[n - 1]))
          n--;
        buf[n] = 0;

        responses[i].text = strdup(buf);
        responses[i].length = n;

        fprintf(stderr, "Response %d from user is '", i);
        fwrite(responses[i].text, 1, responses[i].length, stderr);
        fprintf(stderr, "'\n\n");
    }

    fprintf(stderr,
        "Done. Sending keyboard-interactive responses to server now.\n");
}


static int auth_kb(char *user)
{
  if (libssh2_userauth_keyboard_interactive
        (SSHsession, user, &kbd_callback))
  {
    eprintf("interactive authentication failed.\n");
    return 0;
  }
  return 1;
}

#line 184 "/home/dodo/tmp/dsync-1.0/src/sftp.u"

int sftp_read_file(char *path, uint8_t **buffer, size_t *len)
{
  LIBSSH2_SFTP_HANDLE *handle;
  int R;

  *buffer= NULL; *len= 0;

  handle= sftp_open(path, 'r');
  R= 1;
  if (!handle) goto E_open;

  R= block_read(handle,(void*) libssh2_sftp_read, (char**) buffer, len);
  if (R)
  {
    eprintf("error during sftp-read: %d\n", R);
  }

  libssh2_sftp_close(handle);

E_open:
  return R;
}

#line 209 "/home/dodo/tmp/dsync-1.0/src/sftp.u"

static LIBSSH2_SFTP_HANDLE *sftp_open(char *path, int mode)
{
  LIBSSH2_SFTP_HANDLE *handle;
  int smode;

  if (mode=='r') smode= LIBSSH2_FXF_READ;
  else           smode= LIBSSH2_FXF_WRITE | LIBSSH2_FXF_CREAT |
                        LIBSSH2_FXF_TRUNC;
  
  handle = libssh2_sftp_open_ex(SFTPsession, path, strlen(path),
                     smode, 0644, LIBSSH2_SFTP_OPENFILE);
  if (!handle)
  {
    eprintf("can't open %s over SFTP: %d\n",path,
              sftp_ecode(libssh2_sftp_last_error(SFTPsession)));
    return NULL;
  }
  return handle;
}


int sftp_write_file(char* path, uint8_t *buffer, size_t len)
{
  LIBSSH2_SFTP_HANDLE *handle;
  int R;
  handle= sftp_open(path, 'w');
  R= 1;
  if (!handle) goto E_open;

  while(len)
  {
    R= libssh2_sftp_write(handle, buffer, len);
    if (R<0) 
    {
      eprintf("error writing file: %d\n", R);
      break;
    } 
    if (R==0)
    {
      eprintf("zero writing file?\n");
      break;
    }
    buffer+= R;
    len-= R;
  }
  if (!len) R= 0;

  libssh2_sftp_close(handle);

E_open:
  return R;
}

#line 19 "/home/dodo/tmp/dsync-1.0/src/list.u"

static void serialize_list(flist_t *L, uint8_t **Rbuffer, size_t *Rlen)
{
  uint8_t *buffer; size_t len;
  flist_t *F;

  len= 0;
  for(F=L->next;F!=L;F=F->next)
  {
    len+= 4 + strlen(F->name)+1; // 4 hex digits= 2 bytes= 64k for a name 
    len+= 16;                    // 16 hex digits= 8 bytes for modtime
  }
  len+= 2;                       // XX for the end of list.

  buffer= malloc(len);
  len= 0;
  for(F=L->next;F!=L;F=F->next)
  {
    int SL;
    len+= hexprt(buffer+len, 8, F->modtime);
    SL= strlen(F->name)+1;
    len+= hexprt(buffer+len, 2, SL);
    memcpy(buffer+len, F->name, SL);
    len+= SL;
  }
  buffer[len++]= 'X';
  buffer[len++]= 'X';

  *Rbuffer= buffer;
  *Rlen= len;
}

static int hexprt(uint8_t *T, int bytes, uint64_t value)
{
   int i;
   value= value<<((8-bytes)*8);
   for(i=0;i<bytes;i++)
   {
     uint64_t K; uint32_t B;
     K= value>>56;
     B= K & 0xff;
     T+= bytep(T, B);
     value= value<<8;
   }
   return bytes*2;
}

#line 70 "/home/dodo/tmp/dsync-1.0/src/list.u"

static int hexget(uint8_t *T, int bytes, uint64_t *RV)
{
  int i;
  uint64_t V;
  V= 0;
  for(i=0;i<bytes;i++)
  {
    uint32_t K;
    T+= byteg(T, &K);
    V= (V<<8) | K;
  }
  *RV= V;
  return bytes*2;

}

static int bytep(uint8_t *b, uint32_t V)
{
  b[0]= ((V>>4)&0xf) + 'a';
  b++;
  b[0]= (V&0xf) + 'a';
  return 2;
}

static int byteg(uint8_t *b, uint32_t *RV)
{
  *RV= ((b[0]-'a')<<4) | (b[1]-'a');
  return 2;
}

#line 105 "/home/dodo/tmp/dsync-1.0/src/list.u"

static flist_t *deserialize_flist(uint8_t *buffer, size_t len)
{
  uint8_t *end;
  flist_t *L;
  uint64_t mtime, SL;
  int found;

  end= buffer+len;
  L= flist_new();
  found= 0;

  while(1)
  {
    if (buffer[0]=='X' && buffer[1]=='X') { found=1; break; }
    if (end-buffer<16) break;
    buffer+= hexget(buffer, 8, &mtime);
    if (end-buffer<4) break;
    buffer+= hexget(buffer, 2, &SL);
    if (end-buffer<SL) break;
    flist_append(L, mtime, buffer);
    buffer+= SL;
  }
  if (!found)
    eprintf("end of file not found in list, we have partial data\n");
  return L;
}

#line 176 "/home/dodo/tmp/dsync-1.0/src/list.u"

flist_t *get_dir_contents()
{
  DIR *dir;
  flist_t *L;
  struct dirent *de;
  struct stat   st;

  dir= opendir(".");
  if (!dir)
  {
    eprintf("opendir: %s\n", strerror(errno));
    return NULL;
  }

  L= flist_new();
  while((de=readdir(dir)))
  {
    if (!strcmp(de->d_name,"dsync.cfg")) continue;
    if (!strcmp(de->d_name,".") || !strcmp(de->d_name,"..")) continue;
    if (stat(de->d_name, &st))
    {
      eprintf("stat %s: %s\n", de->d_name, strerror(errno));
      continue;
    }
    if (!S_ISREG(st.st_mode)) continue;
    flist_append(L, st.st_mtime, de->d_name);
  }
  closedir(dir);
  return L;
}

#line 209 "/home/dodo/tmp/dsync-1.0/src/list.u"

void print_flist(flist_t *L)
{
  flist_t *F;
  printf("FILES\n");
  for(F=L->next;F!=L;F=F->next)
    printf("%16llx %s\n", F->modtime, F->name);
  printf("END\n");
}


void flist_free_node(flist_t *F)
{
  free(F->name); free(F);
}


#line 6 "/home/dodo/tmp/dsync-1.0/src/local.u"

int local_read_file(char *path, uint8_t **buffer, size_t *len)
{
  int R;
  FILE *f;

  R= 1;
  *buffer= NULL; *len= 0;
  f= fopen(path,"r");
  if (!f)
  {
    eprintf("can't open target %s: %s\n", path, strerror(errno));
    goto E_open;
  }

  R= block_read(f,(void*) local_read, (char**) buffer, len);
  if (R)
    eprintf("error during local-read: %d\n", R);

  fclose(f);

E_open:
  return R;
}

int local_read(void *f,char *Z, size_t len)
{
  int R;
  if (feof(f)) return 0;
  R= fread(Z, 1, len, f);
  if (R<0)
    eprintf("error reading file : %s\n", strerror(errno));
  return R;
}

#line 42 "/home/dodo/tmp/dsync-1.0/src/local.u"


int local_write_file(char* path, uint8_t *buffer, size_t len)
{
  FILE *f;
  int R;

  R= 1;
  f= fopen(path, "w");
  if (!f) 
  {
    eprintf("can't open file %s for writing: %s\n" , path, strerror(errno));
    goto E_open;
  }

  while(len)
  {
    R= fwrite(buffer, 1, len, f);
    if (R<0) 
    {
      eprintf("error writing file: %s\n", strerror(errno));
      break;
    } 
    if (R==0)
    {
      eprintf("zero writing file?\n");
      break;
    }
    buffer+= R;
    len-= R;
  }
  if (!len) R= 0;

  fclose(f);

E_open:
  return R;
}

#line 11 "/home/dodo/tmp/dsync-1.0/src/sftp.u"

int sftp_connect(char *host, char *user)
{
  int R,i;
  static int libinit_tried;
  char *emsg;
  const char *fingerprint;
  char *userauthlist;
  int auth_met;

  if (libinit_tried==2) return 1;

  if (!libinit_tried)
  {
     libinit_tried= 1;
     R= libssh2_init (0);
     if (R)
     {
       libinit_tried++; 
       eprintf("couldn't initialize libssh2: (%d)\n", R);
       return 1;
     }
  }

  SSHfd= connect_host_tcp4(host, 22);
  if (SSHfd<0) goto E_conn;

  SSHsession = libssh2_session_init();
  if(!SSHsession)
  {
     eprintf("error: initialize ssh2 session\n");
     goto E_session1;
  }
  libssh2_session_set_blocking(SSHsession, 1);
  R= libssh2_session_handshake(SSHsession, SSHfd);
  if (R)
  {
    libssh2_session_last_error(SSHsession, &emsg, NULL,0); 
    eprintf("Failure establishing SSH session: (%d) %s\n", R,emsg);
    goto E_handshake;
  }

  fingerprint= libssh2_hostkey_hash(SSHsession, LIBSSH2_HOSTKEY_HASH_SHA1);
  eprintf("Fingerprint: ");
  for(i=0;i<20;i++)
     eprintf("%s%02x", i?":": "", (unsigned char)fingerprint[i]);
  eprintf("\n");

  userauthlist = libssh2_userauth_list(SSHsession, user, strlen(user));
  eprintf("Authentication methods: %s\n", userauthlist);

  if (strstr(userauthlist, "password") && auth_passwd(user,host))
    goto auth_OK;
  if (strstr(userauthlist, "keyboard-interactive") && auth_kb(user))
    goto auth_OK;

  eprintf("No usable authentication methods.\n");
  goto E_auth;

auth_OK:
  SFTPsession = libssh2_sftp_init(SSHsession);

  if (!SFTPsession)
  {
    eprintf("Unable to init SFTP session\n");
    goto E_auth;
  }

  eprintf("sftp connection OK.\n");
  return 0;

E_auth:
  libssh2_session_disconnect(SSHsession, "client got confused");
E_handshake:
  libssh2_session_free(SSHsession);
E_session1:
  close(SSHfd);
E_conn:
  libssh2_exit();
  libinit_tried= 2;
  return 1;
}

#line 264 "/home/dodo/tmp/dsync-1.0/src/sftp.u"

void sftp_disconnect()
{
   libssh2_sftp_shutdown(SFTPsession);
   libssh2_session_disconnect(SSHsession,
                           "Normal Shutdown, Thank you for playing");
   libssh2_session_free(SSHsession);
   close(SSHfd);
}
#line 137 "/home/dodo/tmp/dsync-1.0/src/list.u"

flist_t* flist_append(flist_t *L, uint64_t mtime, uint8_t *name)
{
  flist_t *F;
  F= malloc(sizeof(*F));
  F->name= strdup(name);
  F->modtime= mtime;

  return flist_append_node(L,F);
}

flist_t* flist_remove_node(flist_t *F)
{
  F->prev->next= F->next;
  F->next->prev= F->prev;
  return F;
}

flist_t* flist_append_node(flist_t *L, flist_t *F)
{
  F->next= L; F->prev= L->prev;
  L->prev->next= F; L->prev= F;
  return F;
}

flist_t* flist_new()
{
  flist_t *L;
  L= malloc(sizeof(*L));
  L->prev= L->next= L;
  L->name= NULL;
  return L;
}


#line 40 "/home/dodo/tmp/dsync-1.0/src/main.u"


int main(int argc, char **argv)
{
  eprintf_attach(writef, stderr, 'c');
  if (argc==2 && !strcmp(argv[1],"help"))
  {
    show_help();
    exit(0);
  }
  read_config();
  parse_args(argc,argv);

  switch(command)
  {
  case 'L': e_list(); break;
  case 'M': e_mark(); break;
  case 'U': e_update(); break;
  case 'F': force_compare=1; e_update(); break;
  }

#if 0
  flist_t *L;
  L= get_dir_contents();
  print_flist(L);

  uint8_t *B; size_t len;

  serialize_list(L, &B, &len);
  printf("serialized:\n");
  fwrite(B, 1, len, stdout);
  printf("\n");
  L= deserialize_flist(B, len);
  printf("deserialized: \n");
  print_flist(L);
#endif
}

